• LeetCode #134 Gas Station


    Question

    There are N gas stations along a circular route, where the amount of gas at station i is gas[i].

    You have a car with an unlimited gas tank and it costs cost[i] of gas to travel from station i to its next station (i+1). You begin the journey with an empty tank at one of the gas stations.

    Return the starting gas station's index if you can travel around the circuit once in the clockwise direction, otherwise return -1.

    Note:

    • If there exists a solution, it is guaranteed to be unique.
    • Both input arrays are non-empty and have the same length.
    • Each element in the input arrays is a non-negative integer.

    Example 1:

    Input: 
    gas  = [1,2,3,4,5]
    cost = [3,4,5,1,2]
    
    Output: 3
    
    Explanation:
    Start at station 3 (index 3) and fill up with 4 unit of gas. Your tank = 0 + 4 = 4
    Travel to station 4. Your tank = 4 - 1 + 5 = 8
    Travel to station 0. Your tank = 8 - 2 + 1 = 7
    Travel to station 1. Your tank = 7 - 3 + 2 = 6
    Travel to station 2. Your tank = 6 - 4 + 3 = 5
    Travel to station 3. The cost is 5. Your gas is just enough to travel back to station 3.
    Therefore, return 3 as the starting index.
    

    Example 2:

    Input: 
    gas  = [2,3,4]
    cost = [3,4,3]
    
    Output: -1
    
    Explanation:
    You can't start at station 0 or 1, as there is not enough gas to travel to the next station.
    Let's start at station 2 and fill up with 4 unit of gas. Your tank = 0 + 4 = 4
    Travel to station 0. Your tank = 4 - 3 + 2 = 3
    Travel to station 1. Your tank = 3 - 3 + 3 = 3
    You cannot travel back to station 2, as it requires 4 unit of gas but you only have 3.
    Therefore, you can't travel around the circuit once no matter where you start.

    常规想法O(n^2)

    首先要求出gas[i] - cost[i],代表从第 i 站到第 i+1 站得到的油。

    暴力枚举,从 i 站出发,顺时针一站一站走下去,直至到原点,如果中间有总汽油量为负数的情况就排除,直至找到成功的一个。

    时间复杂度 O(n^2)

    优化方法O(n)

    常规想法中其实有重复计算的部分,假设从 i 站到 j 站经检验是

    思路想通后实现就很简单了:

    class Solution:
        def canCompleteCircuit(self, gas: List[int], cost: List[int]) -> int:
            length = len(gas)
            diff = []
            for i in range(length):
                diff.append(gas[i]-cost[i])
            
            total_sum = 0
            current_sum = 0
            current_start = 0
            for i in range(length):
                current_sum += diff[i]
                if current_sum < 0:
                    total_sum += current_sum
                    current_sum = 0
                    current_start = i+1
            if current_sum + total_sum >= 0:
                return current_start
            else:
                return -1

    参考:

    https://blog.csdn.net/qq508618087/article/details/50990076

  • 相关阅读:
    【JZOJ5771】遨游【二分】【DFS】
    【JZOJ5773】简单数学题【数论,数学】
    【JZOJ5773】简单数学题【数论,数学】
    有效壳第2部分:成为一个剪贴板体操运动员
    具有多重选择和列表间拖拽的拖拽列表框
    将枚举绑定到下拉列表框并根据值对其排序
    一个具有子项格式的自定义绘制列表控件
    基本的c#屏幕截图应用程序
    将组合框下拉列表宽度调整为最长字符串宽度
    在应用程序中使用按钮控件
  • 原文地址:https://www.cnblogs.com/sbj123456789/p/12165208.html
Copyright © 2020-2023  润新知